<?php

//----- chrono ----------
$cimtimed = explode(" ",microtime());
$citimedebut = $cimtimed[1] + $cimtimed[0];

include_once("ecrire/inc_version.php3");
include_ecrire("inc_auth.php3");
include_ecrire("inc_session.php3");
include_ecrire('inc_connect.php3');

include_ecrire('_giseh_inc_ari.php3');
include_ecrire('_giseh_inc_auth.php3');
include_ecrire('giseh_commun/securite.php');		// nouveau
include_ecrire('giseh_commun/abstract_sql.php');	// nouveau

define("_CI_SANS_VIRTUEL", "1"); 		// si article virtuel, ne pas rediriger


function cicharger_action($action) {
	include_ecrire('giseh_action/'.$action.'.php');
	if (function_exists($f = 'giseh_action_'.$action))
		return $f;
}


//-------------------------------------------------------
// Vrifier que l'auteur s'est authentifi

if ($_COOKIE['spip_session']) {
	// ncessaire pour inc-calcul
	if (verifier_visiteur()){
		$cilogin = $GLOBALS['auteur_session']['login'];
		$connect_statut=$GLOBALS['auteur_session']['statut'];
		$connect_id_auteur=$GLOBALS['auteur_session']['id_auteur'];
	}
} else {
	$ciurl = urlencode($clean_link->getUrl());
	@header("Location: ./spip_login.php3?url=$ciurl");
	exit;
}


//-------------------------------------------------------
// securite

// on peut interdire la cration/modification darticle depuis le site public
// via un paramtrage par fichier
if (file_exists('ecrire/_config_saisie.php3')) {  
	include_ecrire('_config_saisie.php3');
	if ($GLOBALS['ciconfig']['cisaisie'] == 'non'){
		@header("Location: ./index.php3");
		exit;
	}
}

// cipage=xxxx demandee par l'url est protg par le fonction _cireqsecure
$fond = _cireqsecure('cipage');

// Le contenu de la variable $codeaction est protg par le fonction _cireqsecure
$codeaction = _cireqsecure('ciaction');

$ci_id_rubrique = _cireqsecure('id_rubrique');
$ci_id_article = _cireqsecure('id_article');

$_POST['form_erreur'] = "";


// indispensable pour les templates 
$_GET['id_article']=$ci_id_article;
$_GET['id_rubrique']=$ci_id_rubrique;


//-------------------------------------------------------
// Determiner les droits d'edition de l'article

$array_droits = ci_droit_article($connect_statut, $ci_id_article, $ci_id_rubrique);
$flag_auteur = $array_droits['auteur'];
$flag_editable = $array_droits['editable'];
$ciflag_lecture = $array_droits['lecture'];
$cipeutpublier = $array_droits['publier'];
$cistatut_article = $array_droits['statut_article'];
$rubrique_article = $array_droits['rubrique_article'];


$flag_acces = false;
if (($ci_id_article>0 AND $flag_editable) OR ($ci_id_article==0 AND $ciflag_lecture)) 
	$flag_acces = true;

	
if ($flag_acces) {

	//-------------------------------------------------------
	// forcer le mode previsualisation sauf si l'article est publie
	$var_preview = 'oui';
	if ($ci_id_article>0) {
		 if (_cireqsecure('statut_nouv')=='publie')
			$var_preview = '';
		 elseif ($cistatut_article=='publie' AND !_cireqsecure('statut_nouv'))
			$var_preview = '';
	} else {
		 if (_cireqsecure('statut_nouv')=='publie')
			$var_preview = '';		
	}
	//-------------------------------------------------------
	// Aiguillage pour le bouton "annuler"
	
	if ($_POST['annuler']) {
		if ($codeaction=='editer_article' OR $codeaction=='ajouter_article') {
			redirige_par_entete("rubrique.php3?id_rubrique=".$ci_id_rubrique);
		} else {
			redirige_par_entete("_giseh.php?cipage=article&id_rubrique=".$ci_id_rubrique."&id_article=".$ci_id_article);
		}
	}
	

	//-------------------------------------------------------
	// Appel aux fichiers "action" pour ajouter, modifier, supprimer, ...
	// l'action demande est prioritaire par rapport  cipage
	$retourok = true;
	if ($codeaction) { 
		$f = cicharger_action($codeaction);
		if ($f)
			$retourok = $f($array_droits,$connect_id_auteur,$connect_statut,$cilogin);
	}
	// en cas de cration d'article
	$ci_id_article = _cireqsecure('id_article');
	
	//-------------------------------------------------------
	// valeurs par dfaut
	if (!$fond) $fond = "_template/__giseh_article";
	$delais = 0;
	
	
	//-------------------------------------------------------
	// Aiguillage
	if ($ci_id_article>0) {

		// scurit pour ajout d'un document, d'une image, options avances, action sur un document
		$array_option=array("document","image","vignette","multipj","referpj","logo","raccourci","motcle","redirection","auteur","forme","forum","petition","datepublication","calendrier","rubart","revision","envoimembre","statistique");
		$array_doc_action=array("doc_remplacer","doc_modifier","doc_supprimer");
			
		if (!$retourok){
			// En cas d'erreur
			if (isset($_POST['formulaire'])) {
				$formulaire = $_POST['formulaire'];
				if (in_array($formulaire, $array_option) OR in_array($formulaire, $array_doc_action)) {
						$fond = "_template/__giseh_".$formulaire;
				}
			}
			
		} else {
		
			// redirections
			if ($_POST['previsu']) redirige_par_entete("article.php3?id_article=".$ci_id_article."&var_mode=preview");
			if ($_POST['voirenligne']) redirige_par_entete("article.php3?id_article=".$ci_id_article."&var_mode=calcul");
			if ($_POST['bt_gererforum']) redirige_par_entete("ecrire/articles_forum.php3?id_article=".$ci_id_article);
			if ($_POST['bt_gererpetition']) redirige_par_entete("ecrire/controle_petition.php3?id_article=".$ci_id_article);
			// cas particulier (liens sans formulaire)
			if ($_GET['bt_revision']) $_POST['bt_revision']=$_GET['bt_revision'];
	
			// cas particulier de l'insertion d'un document dans le texte
			if ($codeaction!='editer_document') {
				$ci_ins_document = _cireqsecure('ins_document');
				$ci_ins_image = _cireqsecure('ins_image');
		
				if ($ci_ins_document=="descriptif" OR $ci_ins_document=="texte") $fond = "_template/__giseh_document";
				if ($ci_ins_image=="descriptif" OR $ci_ins_image=="texte") $fond = "_template/__giseh_image";
			}
			
			// ajout d'un document, d'une image, options avances, action sur un document
			if (is_array($_POST)) {
				foreach ($_POST as $key => $val) {
					if (strlen($key)>3) {
						if (substr($key,0,3)=="bt_") {	
							$key = substr($key,3);			
							if (in_array($key, $array_option)) {			
								// ajout d'une option avance, d'un document, d'une image, ...
								$action=$key;
								$fond = "_template/__giseh_".$key;
								break;
							} else {
								foreach ($array_doc_action as $doc_action) {
									// action sur un document
									$len_doc_action= strlen($doc_action);
									if ($len_doc_action>0 AND substr($key,0,$len_doc_action)==$doc_action) {
										$val = substr($key,$len_doc_action);
										if (intval($val)>0) {
											// indispensable pour le template 
											$_GET['id_document']=intval($val);
											$_POST['id_document']=intval($val);
										}
										$fond = "_template/__giseh_".substr($key,0,$len_doc_action);
										break;
									}
								}
							}
						}
					}
				}
			}
				
		}
	}
	// spip_log("CI fond ".$fond);

//------------------------------------------

} elseif ($ci_id_article>0 AND $ciflag_lecture) {
	redirige_par_entete("article.php3?id_article=".$ci_id_article."&var_mode=preview");
} else {
	$fond = "_template/__acces_interdit";
}

//-------------------------------------------------------
// cette ligne empeche l'affichage des boutons d'administration
$flag_preserver = true;

	
include ("inc-public.php3");

?>