<?php

/***************************************************************************\
 *  SPIP, Systeme de publication pour l'internet                           *
 *                                                                         *
 *  Copyright (c) 2001-2008                                                *
 *  Arnaud Martin, Antoine Pitrou, Philippe Riviere, Emmanuel Saint-James  *
 *                                                                         *
 *  Ce programme est un logiciel libre distribue sous licence GNU/GPL.     *
 *  Pour plus de details voir le fichier COPYING.txt ou l'aide en ligne.   *
\***************************************************************************/

if (!defined("_ECRIRE_INC_VERSION")) return;

include_ecrire("inc_meta.php3");
include_ecrire("inc_index.php3");
include_ecrire("inc_texte.php3");
include_ecrire("inc_filtres.php3");
include_ecrire("inc_lang.php3");
include_ecrire("inc_rubriques.php3");



function giseh_action_ajouter_article($array_droits,$connect_id_auteur,$connect_statut,$cilogin) {

	$ci_id_article = _cireqsecure('id_article');
	
	$return = true;
	$ci_id_rubrique = _cireqsecure('id_rubrique');
	$cistatut_nouv = _cireqsecure('statut_nouv');
	$md5_article = _cireqsecure('md5_article');
	$civotreversion="";
	$id_auteur_modif="";
	$ok_nouveau_statut = false;
	
		
	//-------------------------------------------------------
	// Crer l'article le cas chant
	
	if ($ci_id_article==0) {
			$langue_new = '';
			if ($row = cisql_fetsel("lang", "spip_rubriques", "id_rubrique=$ci_id_rubrique"))
				$langue_new = $row["lang"];
	
			if (!$langue_new) $langue_new = lire_meta('langue_site');
			$langue_choisie_new = 'non';
	
			$ci_id_article = cisql_insertq("spip_articles", array(
				'id_rubrique' => $ci_id_rubrique,
				'statut' =>  'prepa',
				'date' => 'NOW()',
				'accepter_forum' => 
					substr(lire_meta('forums_publics'),0,3),
				'lang' => $langue_new,
				'langue_choisie' =>$langue_choisie_new));
	
			cisql_delete("spip_auteurs_articles", "id_article=$ci_id_article");
			cisql_insertq('spip_auteurs_articles', array('id_auteur' => $connect_id_auteur, 'id_article' => $ci_id_article));
			
	
			// Modifier le lien de base pour qu'il prenne en compte le nouvel id
			unset($_POST['id_rubrique']);
			$_POST['id_article'] = $ci_id_article;
			$_GET['id_article'] = $ci_id_article;
			$clean_link = new Link();
			
			// recalcul en cache du tableau des formes pour les rubriques et les articles et l'ordre de tri
			// les articles hritent de la forme des rubriques dans certains cas
			include_ecrire("_giseh_forme_art_rub.php3");
			ci_maj_forme_article();
	}
	
	//-------------------------------------------------------
	// Enregistrer les modifications
	
	if ($ci_id_article>0) {
		
		if ($cistatut_nouv) {
			
			// mode cration
			$flag_auteur = true;	
			if (!$cistatut_article) $cistatut_article = 'prepa';
			
			if (ci_connect_ciredval($ci_id_rubrique) AND $flag_auteur) $ok_nouveau_statut = true;
			if (acces_rubrique($ci_id_rubrique)) $ok_nouveau_statut = true;
			else if ($flag_auteur) {
				if ($cistatut_nouv == 'prop' AND $cistatut_article == 'prepa')
					$ok_nouveau_statut = true;
				else if ($cistatut_nouv == 'prepa' AND $cistatut_article == 'poubelle')
					$ok_nouveau_statut = true;
			}
			if ($ok_nouveau_statut) {
				
				$result = cisql_updateq("spip_articles", array("statut" => $cistatut_nouv), "id_article=$ci_id_article");
		
				if ($cistatut_nouv == 'publie' AND $cistatut_nouv != $cistatut_article) {
					cisql_updateq("spip_articles", array("date" => "NOW()"), "id_article=$ci_id_article");
					calculer_rubriques();
				}
				
				$statut_ancien = $cistatut_article;	// message pour les traitements de fond (indexation ; envoi mail)
				$cistatut_article = $cistatut_nouv;
				$flag_editable = (acces_rubrique($ci_id_rubrique)
					OR ($flag_auteur AND ($cistatut_article == 'prepa' OR $cistatut_article == 'prop')));
				$flag_editable = ($flag_editable OR (ci_connect_ciredval($ci_id_rubrique) AND $flag_auteur));
			
				// 'publie' => reindexer
				if ($ok_nouveau_statut AND $cistatut_nouv == 'publie' AND $cistatut_nouv != $statut_ancien AND (lire_meta('activer_moteur') == 'oui')) {
					include_ecrire ("inc_index.php3");
					marquer_indexer('article', $ci_id_article);
				}
				
				// 'depublie' => invalider les caches
				if ($ok_nouveau_statut AND $statut_ancien == 'publie' AND $cistatut_nouv != $statut_ancien AND $invalider_caches) {
					include_ecrire ("inc_invalideur.php3");
					suivre_invalideur("id='id_article/$ci_id_article'");
				}
				
			}
			
		}
		
		if ($id_auteur_concurrent==0) {
				
				$result = cisql_select("id_auteur", "spip_auteurs", "login='$cilogin'");
				while ($row = spip_fetch_array($result)) {
					$ciauteur = $row["id_auteur"];
				}
				
				if ($ciauteur) $connect_id_auteur = $ciauteur;
				$articles_versions = (lire_meta("articles_versions")=='oui') && $flag_revisions;
	
				$champs = array('titre', 'descriptif', 'texte');
				$champs_version = array();
				foreach ($champs as $nom_champ) {
					$t = $champs_versions[$nom_champ] = corriger_caracteres(_cireqsecure($nom_champ));
					$$nom_champ = $t;	// sans addslash car la couche d'abstraction s'en occupe
				}
				
				if ($titre=='') $titre = "Sans titre";

				
				if ($ciauteur) {
					cisql_updateq("spip_articles", array("titre" => $titre, "descriptif" => $descriptif, "texte" => $texte, "date_modif" => "NOW()", "auteur_modif" => $ciauteur), "id_article=$ci_id_article");
				} else {
					cisql_updateq("spip_articles", array("titre" => $titre, "descriptif" => $descriptif, "texte" => $texte, "date_modif" => "NOW()"), "id_article=$ci_id_article");
				}
	
				
				// Stockage des versions
				if ($articles_versions) {
					include_ecrire("lab_revisions.php");
					ajouter_version($ci_id_article, $champs_versions);
				}
				
				// date de l'vnement dans le calendrier
				if ($dateredaction=_cireqsecure('dateredaction')) {
					$jour = substr($dateredaction,0,2);
					$mois = substr($dateredaction,3,2);
					$annee = substr($dateredaction,6,4);

					$date_redac = sprintf("%04s",$annee) . '-' 
						. sprintf("%02s",$mois) . '-'
						. sprintf("%02s",$jour) . ' ' 
						. sprintf("%02s",0) . ':'
						. sprintf("%02s",0) . ':' 
						. sprintf("%02s",0);
	
					cisql_updateq("spip_articles", array("date_redac" => $date_redac), "id_article=$ci_id_article");
				}
			
				// notifications automatiques
				if ($cistatut_nouv) {
					if ($cistatut_nouv == 'publie' AND $cistatut_nouv != $statut_ancien) {
						include_ecrire("inc_mail.php3");
						envoyer_mail_publication($ci_id_article);
					}
					if ($cistatut_nouv == "prop" AND $statut_ancien != $cistatut_nouv AND $statut_ancien != 'publie') {
						include_ecrire("inc_mail.php3");
						envoyer_mail_proposition($ci_id_article);
					}
				}
		}
	
	}

	return $return;
}

?>
