<?php

/***************************************************************************\
 *  SPIP, Systeme de publication pour l'internet                           *
 *                                                                         *
 *  Copyright (c) 2001-2008                                                *
 *  Arnaud Martin, Antoine Pitrou, Philippe Riviere, Emmanuel Saint-James  *
 *                                                                         *
 *  Ce programme est un logiciel libre distribue sous licence GNU/GPL.     *
 *  Pour plus de details voir le fichier COPYING.txt ou l'aide en ligne.   *
\***************************************************************************/

if (!defined("_ECRIRE_INC_VERSION")) return;

include_ecrire("inc_meta.php3");
include_ecrire("inc_index.php3");
include_ecrire("inc_texte.php3");
include_ecrire("inc_filtres.php3");
include_ecrire("inc_lang.php3");
include_ecrire("inc_rubriques.php3");


function giseh_action_editer_article($array_droits,$connect_id_auteur,$connect_statut,$cilogin) {
	global $flag_editable;
	global $flag_modif;
	global $flag_revisions;
	global $civotreversion;
	global $nom_auteur_modif;
	global $login_auteur_modif;
	global $date_diff;

	$return = true;
	
	$ci_id_article = _cireqsecure('id_article');
	$cititre = _cireqsecure('titre');
	$cistatut_nouv = _cireqsecure('statut_nouv');
	$md5_article = _cireqsecure('md5_article');
	$civotreversion="";
	$id_auteur_modif="";
	$flag_modif = false;
	$ok_nouveau_statut = false;
	$id_auteur_concurrent = 0;
	$nom_auteur_modif = "";
	$login_auteur_modif = "";
	$date_diff = "";
	
	$oldtitre = "";
	$olddescriptif = "";
	$oldtexte = "";
	$oldstatut = "";
	
	$flag_auteur = $array_droits['auteur'];
	$cistatut_article = $array_droits['statut_article'];
	$rubrique_article = $array_droits['rubrique_article'];
	
	//-------------------------------------------------------
	// Enregistrer les modifications
	
	if ($ci_id_article>0) {
	
			
		// accs concurrents
		if ($row = cisql_fetsel("id_article, titre, descriptif, texte, statut, auteur_modif, UNIX_TIMESTAMP(date_modif) AS modification, UNIX_TIMESTAMP(NOW()) AS maintenant", "spip_articles", "id_article=$ci_id_article")) {
			$oldtitre = $row['titre'];
			$olddescriptif = $row['descriptif'];
			$oldtexte = $row['texte'];
			$oldstatut = $row['statut'];
			$id_auteur_modif = $row["auteur_modif"];
			$modification = $row["modification"];
			$maintenant = $row["maintenant"];
			
			$oldmd5article = md5($oldtexte);
			
			// l'article a t modifi entre temps
			if ($md5_article!=$oldmd5article) $id_auteur_concurrent = $id_auteur_modif;
					
		}
		
		if ($id_auteur_concurrent>0) {
			if ($row = cisql_fetsel("*", "spip_auteurs", "id_auteur=$id_auteur_concurrent")) {
				$login_auteur_modif = $row["login"];
				$nom_auteur_modif = $row["nom"];
			}
	
			$date_diff = floor(($maintenant - $modification)/60);
	
			if ($date_diff >= 0 AND $date_diff < 20 AND $id_auteur_concurrent > 0 AND $id_auteur_concurrent != $connect_id_auteur) {
				$flag_modif = true;
			}
			
			if ($flag_modif) {
				$civotreversion = _cireqsecure('texte');
			} else {
				cisql_updateq("spip_articles", array("date_modif" => "NOW()", "auteur_modif" => $ciauteur), "id_article=$ci_id_article");
			}
		}
		
		if ($cistatut_nouv AND $cistatut_nouv!=$oldstatut) {
			if (ci_connect_ciredval($rubrique_article) AND $flag_auteur) $ok_nouveau_statut = true;
			if (acces_rubrique($rubrique_article)) $ok_nouveau_statut = true;
			else if ($flag_auteur) {
				if ($cistatut_nouv == 'prop' AND $cistatut_article == 'prepa')
					$ok_nouveau_statut = true;
				else if ($cistatut_nouv == 'prepa' AND $cistatut_article == 'poubelle')
					$ok_nouveau_statut = true;
			}
			if ($ok_nouveau_statut) {
				$result = cisql_updateq("spip_articles", array("statut" => $cistatut_nouv), "id_article=$ci_id_article");
				
				if ($cistatut_nouv == 'publie' AND $cistatut_nouv != $cistatut_article) {
					cisql_updateq("spip_articles", array("date" => "NOW()"), "id_article=$ci_id_article");
					calculer_rubriques();
				}
		
				$statut_ancien = $cistatut_article;	// message pour les traitements de fond (indexation ; envoi mail)
				$cistatut_article = $cistatut_nouv;
				$flag_editable = (acces_rubrique($rubrique_article)
					OR ($flag_auteur AND ($cistatut_article == 'prepa' OR $cistatut_article == 'prop')));
				$flag_editable = ($flag_editable OR (ci_connect_ciredval($rubrique_article) AND $flag_auteur));
				
				// 'publie' => reindexer
				if ($ok_nouveau_statut AND $cistatut_nouv == 'publie' AND $cistatut_nouv != $statut_ancien AND (lire_meta('activer_moteur') == 'oui')) {
					include_ecrire ("inc_index.php3");
					marquer_indexer('article', $ci_id_article);
				}
				
				// 'depublie' => invalider les caches
				if ($ok_nouveau_statut AND $statut_ancien == 'publie' AND $cistatut_nouv != $statut_ancien AND $invalider_caches) {
					include_ecrire ("inc_invalideur.php3");
					suivre_invalideur("id='id_article/$ci_id_article'");
				}

				
			}
			
		}
	
		if ($id_auteur_concurrent==0) {
			
			// enregistrer que si le titre, le descriptif ou le texte a volu	
			if (corriger_caracteres(_cireqsecure('titre')) != $oldtitre
				OR corriger_caracteres(_cireqsecure('descriptif')) != $olddescriptif
				OR corriger_caracteres(_cireqsecure('texte')) != $oldtexte) {

			
				$result = cisql_select("id_auteur", "spip_auteurs", "login='$cilogin'");
				while ($row = spip_fetch_array($result)) {
					$ciauteur = $row["id_auteur"];
				}
				
				if ($ciauteur) $connect_id_auteur = $ciauteur;
				$articles_versions = (lire_meta("articles_versions")=='oui') && $flag_revisions;
				$champs = array('titre', 'descriptif', 'texte');
				$champs_version = array();
				foreach ($champs as $nom_champ) {
					$t = $champs_versions[$nom_champ] = corriger_caracteres(_cireqsecure($nom_champ));
					$$nom_champ = $t;	// sans addslash car la couche d'abstraction s'en occupe
				}
				
				// Stockage des versions : creer une premiere version si non-existante
				if ($articles_versions) {
					include_ecrire("lab_revisions.php");
					$result = cisql_select("id_article", "spip_versions", "id_article=$ci_id_article", '', '', '0,1');
					
					if (!cisql_count($result)) {
						$select = join(", ", $champs);
						$champs_originaux = cisql_fetsel($select, "spip_articles", "id_article=$ci_id_article");
						$id_version = ajouter_version($ci_id_article, $champs_originaux, _T('version_initiale'));
		
						// Remettre une date un peu ancienne pour la version initiale 
						if ($id_version == 1) // test inutile ?
						cisql_updateq("spip_versions", array("date" => "DATE_SUB(NOW(), INTERVAL 2 HOUR)"), "id_article=$ci_id_article AND id_version=1");
					}
				}
				
				if ($ciauteur) {
					cisql_updateq("spip_articles", array("titre" => $titre, "descriptif" => $descriptif, "texte" => $texte, "date_modif" => "NOW()", "auteur_modif" => $ciauteur), "id_article=$ci_id_article");
				} else {
					cisql_updateq("spip_articles", array("titre" => $titre, "descriptif" => $descriptif, "texte" => $texte, "date_modif" => "NOW()"), "id_article=$ci_id_article");
				}
				
				if ($_POST['voirenligne']) {
					// invalider et reindexer
					if ($cistatut_nouv == 'publie') {
						if (lire_meta('activer_moteur') == 'oui') {
							include_ecrire ("inc_index.php3");
							marquer_indexer('article', $ci_id_article);
						}
						if ($invalider_caches) {
							include_ecrire ("inc_invalideur.php3");
							suivre_invalideur("id='id_article/$ci_id_article'");
						}
					}
				}
				
				
				// Stockage des versions
				if ($articles_versions) {
					ajouter_version($ci_id_article, $champs_versions);
				}

				
				// notifications automatiques
				if ($cistatut_nouv AND $cistatut_nouv!=$oldstatut) {
					if ($cistatut_nouv == 'publie' AND $cistatut_nouv != $statut_ancien) {
						include_ecrire("inc_mail.php3");
						envoyer_mail_publication($ci_id_article);
					}
					if ($cistatut_nouv == "prop" AND $statut_ancien != $cistatut_nouv AND $statut_ancien != 'publie') {
						include_ecrire("inc_mail.php3");
						envoyer_mail_proposition($ci_id_article);
					}
				}				
				
				
			}
		}
	
	}	
	
	return $return;
	
}

?>