<?php

/***************************************************************************\
 *  SPIP, Systeme de publication pour l'internet                           *
 *                                                                         *
 *  Copyright (c) 2001-2008                                                *
 *  Arnaud Martin, Antoine Pitrou, Philippe Riviere, Emmanuel Saint-James  *
 *                                                                         *
 *  Ce programme est un logiciel libre distribue sous licence GNU/GPL.     *
 *  Pour plus de details voir le fichier COPYING.txt ou l'aide en ligne.   *
\***************************************************************************/

if (!defined("_ECRIRE_INC_VERSION")) return;


function giseh_action_editer_article_auteur($array_droits,$connect_id_auteur,$connect_statut,$cilogin) {

	$return = true;
	
	$ci_id_article = _cireqsecure('id_article');
	$auteurs = _cireqsecure('auteurs');
	$ci_auteurs_img_avant = _cireqsecure('cimodif_img_avant');
	
	if ($ci_id_article>0) {
		if (!$auteurs) $auteurs = array();
		$insertauteurs = array();
		$deleteauteurs = array();
		$oldauteurs = array();
		
		if (isset($auteurs['spip_recursions'])) unset($auteurs['spip_recursions']); // subtilit de SPIP
		
		// auteurs de cet article mmoriss dans la base
		$result = cisql_select("id_auteur", "spip_auteurs_articles", "id_article=$ci_id_article","","id_auteur");
		while ($row = spip_fetch_array($result)) {
				$oldauteurs[] = $row['id_auteur'];
		}
			
		// Prvention des accs concurents
		$ci_auteurs_img_base = "";
		if ($oldauteurs) $ci_auteurs_img_base = implode(",", $oldauteurs);
		$ciauteurs_concurrent=false;
		if ($ci_auteurs_img_avant) {
			if ($ci_auteurs_img_base) {
				if (!($ci_auteurs_img_avant==$ci_auteurs_img_base)) $ciauteurs_concurrent=true;
			} else {
				$ciauteurs_concurrent=true;
			}		
		} elseif ($ci_auteurs_img_base) $ciauteurs_concurrent=true;
	
		if (!$ciauteurs_concurrent) {
	
			foreach ($auteurs as $auteur) {
				$auteur = intval($auteur);
				if (in_array($auteur,$oldauteurs)){
					// si le nouvel auteur est le mme que celui en base, ne rien faire
				} elseif ($auteur>0) {
					$insertauteurs[] = $auteur;
				}		
			}
			
			reset($oldauteurs);
			reset($auteurs);
			foreach ($oldauteurs as $oldauteur) {
				$oldauteur = intval($oldauteur);
				if (in_array($oldauteur,$auteurs)){
					// si l'ancien auteur est toujours l, ne rien faire
				} else {
					$deleteauteurs[] = $oldauteur;
				}		
			}
			
			if ($insertauteurs) {
				foreach ($insertauteurs as $insertauteur) {
					cisql_insertq('spip_auteurs_articles', array('id_auteur' => $insertauteur, 'id_article' => $ci_id_article));
				}	
			}
			
			if ($deleteauteurs) {
				foreach ($deleteauteurs as $deleteauteur) {
					cisql_delete("spip_auteurs_articles", "id_auteur=$deleteauteur AND id_article=$ci_id_article");
				}	
			}
			
		}			
		 
	}	

	return $return;
}

?>