<?php

/***************************************************************************\
 *  SPIP, Systeme de publication pour l'internet                           *
 *                                                                         *
 *  Copyright (c) 2001-2005                                                *
 *  Arnaud Martin, Antoine Pitrou, Philippe Riviere, Emmanuel Saint-James  *
 *                                                                         *
 *  Ce programme est un logiciel libre distribue sous licence GNU/GPL.     *
 *  Pour plus de details voir le fichier COPYING.txt ou l'aide en ligne.   *
\***************************************************************************/


//
// Ce fichier ne sera execute qu'une fois
if (defined("_ECRIRE_INC_CONFIG")) return;
define("_ECRIRE_INC_CONFIG", "1");

include_ecrire ("inc_meta.php3");
include_ecrire ("inc_admin.php3");
include_ecrire ("inc_mail.php3");



//
// Appliquer les valeurs par defaut pour les options non initialisees
//
function init_config() {
	// langue par defaut du site = langue d'installation (cookie spip_lang) sinon francais
	if (!$lang = $GLOBALS['spip_lang'])
		$lang = 'fr';

//--------- Debut ajout CI (config specifique) -----
//--------- Fin ajout CI ---------------------
		
	$liste_meta = array(
		'activer_breves' => 'non',
		'config_precise_groupes' => 'oui',
		'mots_cles_forums' =>  'non',
		'articles_surtitre' => 'non',
		'articles_soustitre' => 'non',
		'articles_descriptif' => 'oui',
		'articles_chapeau' => 'non',
		'articles_ps' => 'non',
		'articles_redac' => 'oui',
		'articles_mots' => 'oui',
		'post_dates' => 'oui',
		'articles_urlref' => 'non',
//--------- Debut ajout CI (petit logo) -----
		'creer_preview' => 'non',
//		'taille_preview' => 150,
		'taille_preview' => 44,
//--------- Fin ajout CI ---------------------
//--------- Debut ajout CI (previsualisation) -----
		'preview' => '1comite',
//--------- Fin ajout CI ---------------------
		'articles_modif' => 'oui',

		'activer_sites' => 'oui',
		'proposer_sites' => 0,
		'activer_syndic' => 'oui',
		'visiter_sites' => 'non',
		'moderation_sites' => 'non',

		'forums_publics' => 'posteriori',
		'accepter_inscriptions' => 'non',
		'accepter_visiteurs' => 'non',
		'prevenir_auteurs' => 'non',
		'suivi_edito' => 'non',
		'quoi_de_neuf' => 'non',
		'forum_prive_admin' => 'non',

		'activer_moteur' => 'oui',
		'articles_versions' => 'non',
		'articles_ortho' => 'non',
		'preview' => 'non',
		'activer_statistiques' => 'non',

		'documents_article' => 'oui',
		'documents_rubrique' => 'non',
		'charset' => 'iso-8859-1',

//--------- Debut ajout CI (sites intranet) ---------------------
		'equip_campagne_gouv' => 'non',
		'equip_abonnement_xiti' => '',
		'equip_motcle_accueil' => '',
		'equip_nom_bandeau' => '',
		'equip_haut' => 'prop',
		'equip_nbactu' => '5',
		'equip_menu_niveau' => '3',
		'equip_gauche_rubrique' => 'freres',
		'equip_gauche_article' => 'freres_et_articlesmememotcle',
		'equip_droite_rubrique' => 'sitesreferences',
		'equip_droite_article' => 'logo_seul',
		'equip_sommaire' => '',
		'equip_motcle_version' => '220200',
		'equip_telecommande' => '',
//--------- Fin ajout CI ---------------------
		
		'creer_htpasswd' => 'non',
		'creer_htaccess' => 'non',

		'langue_site' => $lang,

		'multi_articles' => 'non',
		'multi_rubriques' => 'non',
		'multi_secteurs' => 'non',
		'gerer_trad' => 'non',
		'langues_multilingue' => $GLOBALS['all_langs']
	);

//--------- Debut ajout CI (methode de fabrication) -----	
if (defined('_CI_CHOIX_GD2')) {
		$liste_meta['image_process'] = 'gd2';
		$liste_meta['formats_graphiques'] = 'gif,jpg,png';
		$liste_meta['gd_formats_read'] = 'gif,jpg,png';
		$liste_meta['creer_preview'] = 'oui';
		$liste_meta['gd_formats'] = 'gif,jpg,png';
}
//--------- Fin ajout CI ---------------------
//--------- Debut ajout CI (config specifique) -----
if (defined('_CI_DEFAULT_CSS')) {
		$liste_meta['equip_css'] = _CI_DEFAULT_CSS;
} else {
		$liste_meta['equip_css'] = '_css/style_site_intraano_bleu_1024.css';
}	
//--------- Fin ajout CI ---------------------
	
	while (list($nom, $valeur) = each($liste_meta)) {
		if (!lire_meta($nom)) {
			ecrire_meta($nom, $valeur);
			$modifs = true;
		}
	}

	// Cas particulier : charset regle a utf-8 uniquement si nouvelle installation
	if (lire_meta('nouvelle_install') == 'oui') {
		//ecrire_meta('charset', 'utf-8');
		effacer_meta('nouvelle_install');
		$modifs = true;
	}

	if ($modifs) ecrire_metas();
}


function avertissement_config() {
	global $spip_lang_right, $spip_lang_left;
	debut_boite_info();

	echo "<div class='verdana2' align='justify'>
	<p align='center'><B>"._T('avis_attention')."</B></p>",
	  http_img_pack("warning.gif", addslashes(_T('avis_attention')), "width='48' height='48' align='$spip_lang_right' style='padding-$spip_lang_left: 10px;'");

	echo _T('texte_inc_config');

	echo "</div>";

	fin_boite_info();
	echo "<p>&nbsp;<p>";
}


function bouton_radio($nom, $valeur, $titre, $actif = false, $onClick="") {
	static $id_label = 0;
	
	if (strlen($onClick) > 0) $onClick = " onClick=\"$onClick\"";
	$texte = "<input type='radio' name='$nom' value='$valeur' id='label_$id_label'$onClick";
	if ($actif) {
		$texte .= ' checked';
		$titre = '<b>'.$titre.'</b>';
	}
	$texte .= "> <label for='label_$id_label'>$titre</label>\n";
	$id_label++;
	return $texte;
}


function afficher_choix($nom, $valeur_actuelle, $valeurs, $sep = "<br>") {
	while (list($valeur, $titre) = each($valeurs)) {
		$choix[] = bouton_radio($nom, $valeur, $titre, $valeur == $valeur_actuelle);
	}
	echo "\n".join($sep, $choix);
}


//
// Gestion des modifs
//

function appliquer_modifs_config() {
	global $clean_link, $connect_id_auteur;
	global $adresse_site, $email_webmaster, $email_envoi, $post_dates, $tester_proxy, $test_proxy, $http_proxy, $activer_moteur;
	global $forums_publics, $forums_publics_appliquer;
	global $charset, $charset_custom, $langues_auth;

	$adresse_site = ereg_replace("/$", "", $adresse_site);

	// Purger les squelettes si un changement de meta les affecte
	if ($post_dates AND ($post_dates != lire_meta("post_dates")))
		$purger_skel = true;
	if ($forums_publics AND ($forums_publics != lire_meta("forums_publics")))
		$purger_skel = true;

//--------- Debut ajout CI (convergence) ------
	global $equip_css;
	// Purger les squelettes le cas echeant
	if ($equip_css AND lire_meta("equip_css")) {
		$cipos = strpos($equip_css, "style_site_") + 11;
		$ciextrait = substr($equip_css,$cipos);
		$cipos2 = strpos($ciextrait,"_");
		if (!$cipos2) 
			$cipos2 = strpos($ciextrait,".");	      			
		if (substr($equip_css,11,$cipos2) != substr(lire_meta("equip_css"),11,$cipos2))
			$purger_skel = true;
	}
	// Mesure anti hack d'url	
	$cigabarit ="intra";
	$cifiltrecss="";
	if (cilire_config('citypesite')=="inter") {
		$cigabarit ="inter";
	}
	if (cilire_config('cibandeau') AND strlen(trim(cilire_config('cibandeau')))>0) {
		if (cilire_config('cibandeau')=="anonyme" OR cilire_config('cibandeau')=="extranet") {
			// compatibilit ascendante
			$cigabarit .= substr(cilire_config('cibandeau'),0,3);
		} else {
			$cigabarit .= cilire_config('cibandeau');			
		}
	} else {
		if (defined('_CI_FILTRE_CSS_SEN')) {
			$cifiltrecss = explode(" ",_CI_FILTRE_CSS_SEN);
		}	
	}	
	if ($equip_css AND (substr($equip_css,strpos($equip_css,"style_site_")+11,strlen($cigabarit)) != $cigabarit))
		$equip_css = lire_meta("equip_css");

	if ($cifiltrecss) {
		$cipos = strpos($equip_css, "style_site_") + 11;
		$ciextrait = substr($equip_css,$cipos);
		$cipos2 = strpos($ciextrait,"_");
		if (!$cipos2) $cipos2 = strpos($ciextrait,".");	      			
		if (in_array(substr($ciextrait,0,$cipos2), $cifiltrecss)) {
  			$equip_css = lire_meta("equip_css");
		}
	}
		
//--------- Fin ajout CI -----

	// Appliquer les changements de moderation forum
	// forums_publics_appliquer : futur, saufnon, tous
	$accepter_forum = substr($forums_publics,0,3);
	$requete_appliquer = ($forums_publics_appliquer == 'saufnon') ?
		"UPDATE spip_articles SET accepter_forum='$accepter_forum'
		WHERE accepter_forum != 'non'" : 
		(($forums_publics_appliquer == 'tous') ?
			"UPDATE spip_articles SET accepter_forum='$accepter_forum'" : '');
	if ($requete_appliquer) spip_query($requete_appliquer);

	if ($accepter_forum == 'abo')
		ecrire_meta('accepter_visiteurs', 'oui');

	// Test du proxy : $tester_proxy est le bouton "submit"

	// http_proxy : ne pas prendre en compte la modif si le password est '****'
	if (preg_match(',:\*\*\*\*@,', $http_proxy))
		$http_proxy = lire_meta('http_proxy');

	if ($tester_proxy) {
		if (!$test_proxy) {
			echo _T('info_adresse_non_indiquee');
			exit;
		} else {
			include_ecrire("inc_sites.php3");
			$page = recuperer_page($test_proxy, true);
			if ($page)
				echo "<pre>".entites_html($page)."</pre>";
			else
				echo _T('info_impossible_lire_page', array('test_proxy' => $test_proxy))." <tt>".no_password_proxy_url($http_proxy)."</tt>.".aide('confhttpproxy');
			exit;
		}
	}

	// Activer le moteur : dresser la liste des choses a indexer
	if ($activer_moteur == 'oui' AND ($activer_moteur != lire_meta("activer_moteur"))) {
		include_ecrire('inc_index.php3');
		creer_liste_indexation();
	}

	if ($langues_auth) {
		$GLOBALS['langues_multilingue'] = join($langues_auth, ",");
	}

	if (isset($email_webmaster))
		ecrire_meta("email_webmaster", $email_webmaster);
	if (isset($email_envoi))
		ecrire_meta("email_envoi", $email_envoi);
	if ($charset == 'custom') $charset = $charset_custom;

	$liste_meta = array(
		'nom_site',
		'adresse_site',

		'activer_breves',
		'config_precise_groupes',
		'mots_cles_forums',
		'articles_surtitre',
		'articles_soustitre',
		'articles_descriptif',
		'articles_chapeau',
		'articles_ps',
		'articles_redac',
		'articles_mots',
		'post_dates',
		'articles_urlref',
		'creer_preview',
		'taille_preview',
//--------- Debut ajout CI (petit logo) ------
		'gd_formats',
//--------- Fin ajout CI ---------------------
		'articles_modif',

		'activer_sites',
		'proposer_sites',
		'activer_syndic',
		'visiter_sites',
		'moderation_sites',
		'http_proxy',

		'forums_publics',
		'accepter_inscriptions',
		'accepter_visiteurs',
		'prevenir_auteurs',
		'suivi_edito',
		'adresse_suivi',
		'adresse_suivi_inscription',
		'quoi_de_neuf',
		'adresse_neuf',
		'jours_neuf',
		'forum_prive_admin',

		'activer_moteur',
		'articles_versions',
		'articles_ortho',
		'preview',
		'activer_statistiques',

		'documents_article',
		'documents_rubrique',

		'charset',

//--------- Debut ajout CI ---------------------
		'equip_campagne_gouv',
		'equip_motcle_accueil',
		'equip_nom_bandeau',
		'equip_droite_article',
		'equip_gauche_article',
		'equip_droite_rubrique',
		'equip_gauche_rubrique',
		'equip_nbactu',
		'equip_haut',
		'equip_css',
		'equip_menu_niveau',
		'equip_abonnement_xiti',
		'equip_sommaire',
		'equip_telecommande',
//--------- Fin ajout CI ---------------------		
		
		'multi_articles',
		'multi_rubriques',
		'multi_secteurs',
		'gerer_trad',
		'langues_multilingue'
	);
	// Modification du reglage accepter_inscriptions => vider le cache
	// (pour repercuter la modif sur le panneau de login)
	if (isset($GLOBALS['accepter_inscriptions'])
	AND ($GLOBALS['accepter_inscriptions']
	!= lire_meta('accepter_inscriptions'))) {
		include_ecrire('inc_invalideur.php3');
		suivre_invalideur("1"); # tout effacer
	}

	while (list(,$i) = each($liste_meta))
		if (isset($GLOBALS[$i])) ecrire_meta($i, $GLOBALS[$i]);

	// langue_site : la globale est mangee par inc_version
	if ($lang = $GLOBALS['changer_langue_site']) {
		$lang2 = $GLOBALS['spip_lang'];
		if (changer_langue($lang)) {
			ecrire_meta('langue_site', $lang);
			changer_langue($lang2);
		}
	}

	ecrire_metas();

	// modifs de secu (necessitent une authentification ftp)
	$liste_meta = array(
			    'creer_htpasswd',
			    'creer_htaccess'
	);
	while (list(,$i) = each($liste_meta))
		if (isset($GLOBALS[$i]) AND ($GLOBALS[$i] != lire_meta($i)))
			$modif_secu=true;
	if ($modif_secu) {
		include_ecrire('inc_admin.php3');
		$admin = _T('info_modification_parametres_securite');
		debut_admin($admin);
		reset($liste_meta);
		while (list(,$i) = each($liste_meta))
			if (isset($GLOBALS[$i])) ecrire_meta($i, $GLOBALS[$i]);
		ecrire_metas();
		fin_admin($admin);
	}

	if ($purger_skel) {
		redirige_par_entete("../spip_cache.php3?purger_squelettes=oui&id_auteur=$connect_id_auteur&hash=" .
				    calculer_action_auteur("purger_squelettes") .
				    "&redirect=".  _DIR_RESTREINT_ABS .
				    urlencode($clean_link->getUrl()));
	}
}

?>
